local Enchanter= {
    version = 0.08,
    listview = nil

}

Enchanter.name = "Enchanter"
Enchanter.command = "/ench"
Enchanter.version	= "v1.1.1"
Enchanter.settingsVersion = 1;
Enchanter.Potency = {
					--Additive
				haveAdditive = false;
				Jora = false;
				Porade = false;
				Jera = false;
				Jejora = false;
				Odra = false;
				Pojora = false;
				Edora = false;
				Jaera = false;
				Pora = false;
				Denara = false;
				Rera = false;
				Derado  = false;
				Rekura  = false;
				Kura  = false;

				--Subtractive
				haveSubtractive = false;
				Jode  = false;
				Notade = false;
				Ode = false;
				Tade = false;
				Jayde = false;
				Edode = false;
				Pojode = false;
				Rekude = false;
				Hade = false;
				Idode = false;
				Pode = false;
				Kedeko = false;
				Rede = false;
				Kude = false;
			}

Enchanter.Essence = {
				Dakeipa = false;
				Deni = false;
				Denima = false;
				Deteri = false;
				Haoko = false;
				Kaderi = false;
				Kuoko = false;
				Makderi = false;
				Makko = false;
				Makkoma = false;
				Meip = false;
				Oko = false;
				Okoma = false;
				Okori = false;
				Oru = false;
				Rakeipa = false;
				Taderi = false;

				}
Enchanter.Aspect = {
				hasAspect = false;
				Ta = false;
				Jejota = false;
				Denata = false;
				Rekuta = false;
				Kuta = false;
			}

function Enchanter.resetRunes()
Enchanter.Potency = {
					--Additive
				haveAdditive = false;
				Jora = false;
				Porade = false;
				Jera = false;
				Jejora = false;
				Odra = false;
				Pojora = false;
				Edora = false;
				Jaera = false;
				Pora = false;
				Denara = false;
				Rera = false;
				Derado  = false;
				Rekura  = false;
				Kura  = false;

				--Subtractive
				haveSubtractive = false;
				Jode  = false;
				Notade = false;
				Ode = false;
				Tade = false;
				Jayde = false;
				Edode = false;
				Pojode = false;
				Rekude = false;
				Hade = false;
				Idode = false;
				Pode = false;
				Kedeko = false;
				Rede = false;
				Kude = false;
			}

Enchanter.Essence = {
				Dakeipa = false;
				Deni = false;
				Denima = false;
				Deteri = false;
				Haoko = false;
				Kaderi = false;
				Kuoko = false;
				Makderi = false;
				Makko = false;
				Makkoma = false;
				Meip = false;
				Oko = false;
				Okoma = false;
				Okori = false;
				Oru = false;
				Rakeipa = false;
				Taderi = false;

				}
Enchanter.Aspect = {
				hasAspect = false;
				Ta = false;
				Jejota = false;
				Denata = false;
				Rekuta = false;
				Kuta = false;
			}	
end

function Enchanter.initialize()
	Enchanter.listview = Unicorn.ListView.new(EnchanterControl, {
        title = "|cccccccEnchanter |cffff99" .. Enchanter.version,
        width = 700,
        left = 400,
        top = 40,
		height = 750;
    })
	Enchanter.listview.control:SetHidden(true)
	EVENT_MANAGER:RegisterForEvent("Enchanter", EVENT_CRAFTING_STATION_INTERACT, Enchanter.on_start_enchanting_station)
	EVENT_MANAGER:RegisterForEvent("Enchanter", EVENT_END_CRAFTING_STATION_INTERACT, Enchanter.on_end_enchanting_station)
	EVENT_MANAGER:RegisterForEvent("Enchanter", EVENT_CRAFT_COMPLETED, Enchanter.on_end_enchantment)

end



function Enchanter.on_start_enchanting_station(event_type, crafting_type)
if (crafting_type == CRAFTING_TYPE_ENCHANTING) then
	Enchanter.printAvailRunes()
end

end

function Enchanter.on_end_enchantment(crafting_type)
	if(crafting_type == CRAFTING_TYPE_ENCHANTING) then
		Enchanter.printAvailRunes()
	end
end


local function on_addon_load(eventCode, addOnName)
    if addOnName == "Enchanter" then
        Enchanter.initialize()
    end
	EVENT_MANAGER:RegisterForEvent("Enchanter", EVENT_ADD_ON_LOADED, on_addon_load)
end



function Enchanter.on_end_enchanting_station(event_type, crafting_type)
	Enchanter.listview.control:SetHidden(true)
end

function Enchanter.getAspectRunes()
	local bagSize = GetBagSize(1)
	local bankSize = GetBagSize(2)
	-- d(bagSize)
	-- d(bankSize)

	for i = 1, bankSize	do
		local itemName = GetItemName(2, i)
		
		if(itemName == "Ta^N") then
			Enchanter.Aspect.Ta = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Jejota^N") then
			Enchanter.Aspect.Jejota = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Denata^N") then
			Enchanter.Aspect.Denata = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Rekuta^N") then
			Enchanter.Aspect.Rekuta = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Kuta^N") then
			Enchanter.Aspect.Kuta = true
			Enchanter.Aspect.hasAspect = true
		end
	end

	for i = 1, bagSize do
		local itemName = GetItemName(1, i)

		if(itemName == "Ta^N") then
			Enchanter.Aspect.Ta = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Jejota^N") then
			Enchanter.Aspect.Jejota = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Denata^N") then
			Enchanter.Aspect.Denata = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Rekuta^N") then
			Enchanter.Aspect.Rekuta = true
			Enchanter.Aspect.hasAspect = true
		end

		if(itemName == "Kuta^N") then
			Enchanter.Aspect.Kuta = true
			Enchanter.Aspect.hasAspect = true
		end

	end
end


function Enchanter.getEssenceRunes()
	local bagSize = GetBagSize(1)
	local bankSize = GetBagSize(2)

	for i = 1, bankSize do
		local itemName = GetItemName(2, i)
		if(itemName == "Dakeipa^N") then
			Enchanter.Essence.Dakeipa = true
		end

		if(itemName == "Deni^N") then
			Enchanter.Essence.Deni = true
		end

		if(itemName == "Denima^N") then
			Enchanter.Essence.Denima = true
		end

		if(itemName == "Deteri^N") then
			Enchanter.Essence.Deteri = true
		end

		if(itemName == "Haoko^N") then
			Enchanter.Essence.Haoko = true
		end

		if(itemName == "Kaderi^N") then
			Enchanter.Essence.Kaderi = true
		end

		if(itemName == "Kuoko^N") then
			Enchanter.Essence.Kuoko = true
		end

		if(itemName == "Makderi^N") then
			Enchanter.Essence.Makderi = true
		end

		if(itemName == "Makko^N") then
			Enchanter.Essence.Makko = true
		end

		if(itemName == "Makkoma^N") then
			Enchanter.Essence.Makkoma = true
		end

		if(itemName == "Meip^N") then
			Enchanter.Essence.Meip = true
		end

		if(itemName == "Oko^N") then
			Enchanter.Essence.Oko = true
		end

		if(itemName == "Okoma^N") then
			Enchanter.Essence.Okoma= true
		end

		if(itemName == "Okori^N") then
			Enchanter.Essence.Okori = true
		end

		if(itemName == "Oru^N") then
			Enchanter.Essence.Oru = true
		end

		if(itemName == "Rakeipa^N") then
			Enchanter.Essence.Rakeipa= true
		end

		if(itemName == "Taderi^N") then
			Enchanter.Essence.Taderi= true
		end
	end

	for i = 1, bagSize do
		local itemName = GetItemName(1, i)
		if(itemName == "Dakeipa^N") then
			Enchanter.Essence.Dakeipa = true
		end

		if(itemName == "Deni^N") then
			Enchanter.Essence.Deni = true
		end

		if(itemName == "Denima^N") then
			Enchanter.Essence.Denima = true
		end

		if(itemName == "Deteri^N") then
			Enchanter.Essence.Deteri = true
		end

		if(itemName == "Haoko^N") then
			Enchanter.Essence.Haoko = true
		end

		if(itemName == "Kaderi^N") then
			Enchanter.Essence.Kaderi = true
		end

		if(itemName == "Kuoko^N") then
			Enchanter.Essence.Kuoko = true
		end

		if(itemName == "Makderi^N") then
			Enchanter.Essence.Makderi = true
		end

		if(itemName == "Makko^N") then
			Enchanter.Essence.Makko = true
		end

		if(itemName == "Makkoma^N") then
			Enchanter.Essence.Makkoma = true
		end

		if(itemName == "Meip^N") then
			Enchanter.Essence.Meip = true
		end

		if(itemName == "Oko^N") then
			Enchanter.Essence.Oko = true
		end

		if(itemName == "Okoma^N") then
			Enchanter.Essence.Okoma= true
		end

		if(itemName == "Okori^N") then
			Enchanter.Essence.Okori = true
		end

		if(itemName == "Oru^N") then
			Enchanter.Essence.Oru = true
		end

		if(itemName == "Rakeipa^N") then
			Enchanter.Essence.Rakeipa= true 
		end

		if(itemName == "Taderi^N") then
			Enchanter.Essence.Taderi= true
		end
	end
end



function Enchanter.getPotencyRunes()
	local bagSize = GetBagSize(1)
	local bankSize = GetBagSize(2)

	for i = 1, bankSize do
		local itemName = GetItemName(2, i)

		--Additve Potency Runes
		if(itemName == "Jora^N") then
			Enchanter.Potency.Jora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Porade^N") then
			Enchanter.Potency.Porade = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Jera^N") then
			Enchanter.Potency.Jera = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Jejora^N") then
			Enchanter.Potency.Jejora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Odra^N") then
			Enchanter.Potency.Odra = true
			Enchanter.Potency.haveAdditive = true
		end
		if(itemName == "Pojora^N") then
			Enchanter.Potency.Pojora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Edora^N") then
			Enchanter.Potency.Edora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Jaera^N") then
			Enchanter.Potency.Jaera = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Pora^N") then
			Enchanter.Potency.Pora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Denara^N") then
			Enchanter.Potency.Denara = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Rera^N") then
			Enchanter.Potency.Rera = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Derado^N") then
			Enchanter.Potency.Derado = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Rekura^N") then
			Enchanter.Potency.Rekura = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Kura^N") then
			Enchanter.Potency.Kura = true
			Enchanter.Potency.haveAdditive = true
		end

		--Subtractive Potency Runes
		if(itemName == "Jode^N") then
			Enchanter.Potency.Jode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Notade^N") then
			Enchanter.Potency.Notade = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Ode^N") then
			Enchanter.Potency.Ode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Tade^N") then
			Enchanter.Potency.Tade = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Jayde^N") then
			Enchanter.Potency.Jayde = true
			Enchanter.Potency.haveSubtractive = true
		end
		if(itemName == "Edode^N") then
			Enchanter.Potency.Edode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Pojode^N") then
			Enchanter.Potency.Pojode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Rekude^N") then
			Enchanter.Potency.Rekude = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Hade^N") then
			Enchanter.Potency.Hade = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Idode^N") then
			Enchanter.Potency.Idode  = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Pode^N") then
			Enchanter.Potency.Pode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Kedeko^N") then
			Enchanter.Potency.Kedeko = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Rede^N") then
			Enchanter.Potency.Rede = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Kude^N") then
			Enchanter.Potency.Kude = true
			Enchanter.Potency.haveSubtractive = true
		end

	end

	for i = 1, bankSize do
		local itemName = GetItemName(1, i)
			--Additve Potency Runes
		if(itemName == "Jora^N") then
			Enchanter.Potency.Jora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Porade^N") then
			Enchanter.Potency.Porade = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Jera^N") then
			Enchanter.Potency.Jera = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Jejora^N") then
			Enchanter.Potency.Jejora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Odra^N") then
			Enchanter.Potency.Odra = true
			Enchanter.Potency.haveAdditive = true
		end
		if(itemName == "Pojora^N") then
			Enchanter.Potency.Pojora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Edora^N") then
			Enchanter.Potency.Edora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Jaera^N") then
			Enchanter.Potency.Jaera = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Pora^N") then
			Enchanter.Potency.Pora = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Denara^N") then
			Enchanter.Potency.Denara = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Rera^N") then
			Enchanter.Potency.Rera = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Derado^N") then
			Enchanter.Potency.Derado = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Rekura^N") then
			Enchanter.Potency.Rekura = true
			Enchanter.Potency.haveAdditive = true
		end

		if(itemName == "Kura^N") then
			Enchanter.Potency.Kura = true
			Enchanter.Potency.haveAdditive = true
		end

		--Subtractive Potency Runes
		if(itemName == "Jode^N") then
			Enchanter.Potency.Jode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Notade^N") then
			Enchanter.Potency.Notade = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Ode^N") then
			Enchanter.Potency.Ode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Tade^N") then
			Enchanter.Potency.Tade = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Jayde^N") then
			Enchanter.Potency.Jayde = true
			Enchanter.Potency.haveSubtractive = true
		end
		if(itemName == "Edode^N") then
			Enchanter.Potency.Edode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Pojode^N") then
			Enchanter.Potency.Pojode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Rekude^N") then
			Enchanter.Potency.Rekude = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Hade^N") then
			Enchanter.Potency.Hade = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Idode^N") then
			Enchanter.Potency.Idode  = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Pode^N") then
			Enchanter.Potency.Pode = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Kedeko^N") then
			Enchanter.Potency.Kedeko = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Rede^N") then
			Enchanter.Potency.Rede = true
			Enchanter.Potency.haveSubtractive = true
		end

		if(itemName == "Kude^N") then
			Enchanter.Potency.Kude = true
			Enchanter.Potency.haveSubtractive = true
		end

	end
end

function Enchanter.AdativePotencyCheck()
	
	text = {}
	zeile1 = " Machtrune: "
	green = "|c66FF00 "
	blue1 = "|cB2CCE5 "
	blue2 = "|c99B2E5 "
	
	if(Enchanter.Potency.Jora == true) then
		zeile1 = zeile1..blue1.."1-10"..green.."Jora,"
	else
		zeile1 = zeile1..blue1.."1-10 Jora,"
	end
	if(Enchanter.Potency.Porade == true) then
		zeile1 = zeile1..blue2.."/ 5-15"..green.."Porade"
	else
		zeile1 = zeile1..blue2.."/ 5-15 Porade"
	end
	if(Enchanter.Potency.Jera == true) then
		zeile1 = zeile1..blue1.."/ 10-20"..green.."Jera"
	else
		zeile1 = zeile1..blue1.."/ 10-20 Jera"	
	end
	if(Enchanter.Potency.Jejora == true) then
		zeile1 = zeile1..blue2.."/ 15-25"..green.."Jejora"
	else
		zeile1 = zeile1..blue2.."/ 15-25 Jejora"	
	end
	if(Enchanter.Potency.Odra == true) then
		zeile1 = zeile1..blue1.."/ 20-30"..green.."Odra"
	else
		zeile1 = zeile1..blue1.."/ 20-30 Odra"	
	end
	if(Enchanter.Potency.Pojora == true) then
		zeile2 = blue1.."/ 25-35"..green.."Pojora"
	else
		zeile2 = blue1.."/ 25-35 Pojora"	
	end
	if(Enchanter.Potency.Edora == true) then
		zeile2 = zeile2..blue2.."/ 30-40"..green.."Edora"
	else
		zeile2 = zeile2..blue2.."/ 30-40 Edora"	
	end
	if(Enchanter.Potency.Jaera == true) then
		zeile2 = zeile2..blue1.."/ 35-45"..green.."Jaera"
	else
		zeile2 = zeile2..blue1.."/ 35-45 Jaera"	
	end
	if(Enchanter.Potency.Pora == true) then
		zeile2 = zeile2..blue2.."/ 40-50"..green.."Pora"
	else
		zeile2 = zeile2..blue2.."/ 40-50 Pora"	
	end
	if(Enchanter.Potency.Denara == true) then
		zeile2 = zeile2..blue1.."/ VR1-VR3"..green.."Denara"
	else
		zeile2 = zeile2..blue1.."/ VR1-VR3 Denara"	
	end
	if(Enchanter.Potency.Rera == true) then
		zeile3 = blue1.."/ VR3-VR5"..green.."Rera"
	else
		zeile3 = blue1.."/ VR3-VR5 Rera"	
	end
	if(Enchanter.Potency.Derado == true) then
		zeile3 = zeile3..blue2.."/ VR5-VR7"..green.."Derado"
	else
		zeile3 = zeile3..blue2.."/ VR5-VR7 Derado"	
	end
	if(Enchanter.Potency.Rekura == true) then
		zeile3 = zeile3..blue1.."/ VR7-VR9"..green.."Rekura"
	else
		zeile3 = zeile3..blue1.."/ VR7-VR9 Rekura"	
	end
	if(Enchanter.Potency.Kura == true) then
		zeile3 = zeile3..blue2.."/ VR10-VR12"..green.."Kura"
	else
		zeile3 = zeile3..blue2.."/ VR10-VR12 Kura"	
	end
	text[1] = zeile1
	text[2] = zeile2
	text[3] = zeile3
	return text
end

function Enchanter.ReduktivPotencyCheck()
	
	text = {}
	zeile1 = " Machtrune: "
	green = "|c66FF00 "
	blue1 = "|cB2CCE5 "
	blue2 = "|c99B2E5 "
	
	if(Enchanter.Potency.Jode == true) then
		zeile1 = zeile1..blue1.."1-10"..green.."Jode"
	else
		zeile1 = zeile1..blue1.."1-10 Jode"
	end
	if(Enchanter.Potency.Notade == true) then
		zeile1 = zeile1..blue2.."/ 5-15"..green.."Notade"
	else
		zeile1 = zeile1..blue2.."/ 5-15 Notade"
	end
	if(Enchanter.Potency.Ode == true) then
		zeile1 = zeile1..blue1.."/ 10-20"..green.."Ode"
	else
		zeile1 = zeile1..blue1.."/ 10-20 Ode,"
	end
	if(Enchanter.Potency.Tade == true) then
		zeile1 = zeile1..blue2.."/ 15-25"..green.."Tade"
	else
		zeile1 = zeile1..blue2.."/ 15-25 Tade,"
	end
	if(Enchanter.Potency.Jayde == true) then
		zeile1 = zeile1..blue1.."/ 20-30"..green.."Jayde"
	else
		zeile1 = zeile1..blue1.."/ 20-30 Jayde"
	end
	if(Enchanter.Potency.Edode == true) then
		zeile2 = blue1.."/ 25-35"..green.."Edode"
	else
		zeile2 = blue1.."/ 25-35 Edode"
	end
	if(Enchanter.Potency.Pojode == true) then
		zeile2 = zeile2..blue2.."/ 30-40"..green.."Pojode"
	else
		zeile2 = zeile2..blue2.."30-40 Pojode"
	end
	if(Enchanter.Potency.Rekude == true) then
		zeile2 = zeile2..blue1.."/ 35-45"..green.."Rekude"
	else
		zeile2 = zeile2..blue1.."/ 35-45 Rekude"
	end
	if(Enchanter.Potency.Hade == true) then
		zeile2 = zeile2..blue2.."/ 40-50"..green.."Hade"
	else
		zeile2 = zeile2..blue2.."/ 40-50 Hade"
	end
	if(Enchanter.Potency.Idode == true) then
		zeile2 = zeile2..blue1.."/ VR1-VR3"..green.."Idode"
	else
		zeile2 = zeile2..blue1.."/ VR1-VR3 Idode"
	end
	if(Enchanter.Potency.Pode == true) then
		zeile3 = blue1.."/ VR3-VR5"..green.."Pode"
	else
		zeile3 = blue1.."/ VR3-VR5 Pode"
	end
	if(Enchanter.Potency.Kedeko == true) then
		zeile3 = zeile3..blue2.."/ VR5-VR7"..green.."Kedeko"
	else
		zeile3 = zeile3..blue2.."/ VR5-VR7 Kedeko"
	end
	if(Enchanter.Potency.Rede == true) then
		zeile3 = zeile3..blue1.."/ VR7-VR9"..green.."Rede"
	else
		zeile3 = zeile3..blue1.."/ VR7-VR9 Rede"
	end
	if(Enchanter.Potency.Kude == true) then
		zeile3 = zeile3..blue2.."/ VR10-VR12"..green.."Kude"
	else
		zeile3 = zeile3..blue2.."/ VR10-VR12 Kude"
	end
	text[1] = zeile1
	text[2] = zeile2
	text[3] = zeile3
	return text
end
function Enchanter.AspectCheck()

	zeile1 = " Aspektrune: "
	green = "|c66FF00 "
	blue1 = "|cB2CCE5 "
	blue2 = "|c99B2E5 "
	
	if(Enchanter.Aspect.Ta == true) then
		zeile1 = zeile1..green.."Ta,"
	else
		zeile1 = zeile1..blue1.."Ta,"
	end
	if(Enchanter.Aspect.Jejota == true) then
		zeile1 = zeile1..green.."Jejota,"
	else
		zeile1 = zeile1..blue2.."Jejota,"
	end
	if(Enchanter.Aspect.Denata == true) then
		zeile1 = zeile1..green.."Denata,"
	else
		zeile1 = zeile1..blue1.."Denata,"
	end
	if(Enchanter.Aspect.Rekuta == true) then
		zeile1 = zeile1..green.."Rekuta,"
	else
		zeile1 = zeile1..blue2.."Rekuta,"
	end
	if(Enchanter.Aspect.Kuta == true) then
		zeile1 = zeile1..green.."Kuta"
	else
		zeile1 = zeile1..blue1.."Kuta"
	end
	return zeile1
end
function Enchanter.printAvailRunes()
	local mw = Enchanter.listview
	mw:clear()
	Enchanter.listview.control:SetHidden(false)
	Enchanter.resetRunes()
	Enchanter.getAspectRunes()
	if(Enchanter.Aspect.hasAspect == false) then
		mw:add_message("|cff0000".."keine Aspektrunen verfügbar")
	

	else
		Enchanter.getPotencyRunes()
		Enchanter.getEssenceRunes()
	
	
	AdativePotency = Enchanter.AdativePotencyCheck()
	ReduktivPotency = Enchanter.ReduktivPotencyCheck()
	Aspect = Enchanter.AspectCheck()
	
--Armor Glyphs
	if((Enchanter.Essence.Makko == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Oko == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Deni == true and Enchanter.Potency.haveAdditive == true) and (Enchanter.Aspect.hasAspect == true	)) then
		
		mw:add_message("|c00ff00".."--Verfügbare Rüstungsglyphen--")
		mw:add_message("")
	end

	if(Enchanter.Essence.Makko == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Magicka")
		mw:add_message("	Essenzrune: |c66FF00 Makko")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Oko == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des Lebens")
		mw:add_message("	Essenzrune: |c66FF00 Oko")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Deni == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Ausdauer")
		mw:add_message("	Essenzrune: |c66FF00 Deni")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

--Weapon Glyphs
	if((Enchanter.Essence.Makko == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Oko == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Deni == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Okoma == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Okori == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Deteri == true and Enchanter.Potency.haveSubtractive == true)

	or (Enchanter.Essence.Dakeipa == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Haoko == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Kuoko == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Meip == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Okori == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Rakeipa == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Deteri == true and Enchanter.Potency.haveAdditive == true)

	and (Enchanter.Aspect.hasAspect == true	)) then
		mw:add_message("")
		mw:add_message("|c00ff00".."--Verfügbare Waffenglyphen--")
		mw:add_message("")
	end

	--Weapon Subtractives

	if(Enchanter.Essence.Makko == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Magickaabsorption")
		mw:add_message("	--Verursacht magischen Schaden und regeneriert Magicka")
		mw:add_message("	Essenzrune: |c66FF00 Makko")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Oko == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Lebensabsorption")
		mw:add_message("	--Verursacht magischen Schaden und regeneriert Leben")
		mw:add_message("	Essenzrune: |c66FF00 Oko")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Okoma == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Lebensminderung")
		mw:add_message("	--Verursacht unvermeidbaren Schaden")
		mw:add_message("	Essenzrune: |c66FF00 Okoma")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Okori == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Schwächung")
		mw:add_message("	--Verringert die Stärke des Ziels 5 Sekunden lang")
		mw:add_message("	Essenzrune: |c66FF00 Okori")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Deni == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Ausdauerabsorption")
		mw:add_message("	--Verursacht Magieschaden und stellt Ausdauer wieder her")
		mw:add_message("	Essenzrune: |c66FF00 Deni")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Deteri == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe des Zerschmetterns")
		mw:add_message("	--Verringert die Rüstung des Ziels 5 Sekunden lang")
		mw:add_message("	Essenzrune: |c66FF00 Deteri")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	--Weapon Additives
	if(Enchanter.Essence.Dakeipa == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des Frosts")
		mw:add_message("	--Verursacht Kälteschaden")
		mw:add_message("	Essenzrune: |c66FF00 Dakeipa")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Haoko == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Fäulnis")
		mw:add_message("	--Verursacht Seuchenschaden")
		mw:add_message("	Essenzrune: |c66FF00 Haoko")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Kuoko == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des Gifts")
		mw:add_message("	--Verursacht Giftschaden")
		mw:add_message("	Essenzrune: |c66FF00 Kuoko")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Meip == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des Schocks")
		mw:add_message("	--Verursacht Schockschaden")
		mw:add_message("	Essenzrune: |c66FF00 Meip")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Okori == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des Zorns")
		mw:add_message("	--Erhöht Eure Kraft 5 Sekunden lang")
		mw:add_message("	Essenzrune: |c66FF00 Okori")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Rakeipa == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Flamme")
		mw:add_message("	--Verursacht Flammenschaden")
		mw:add_message("	Essenzrune: |c66FF00 Rekeipa")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if(Enchanter.Essence.Deteri == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Abhärtung")
		mw:add_message("	--Gewährt 5 Sekunden lang einen Schadensschild")
		mw:add_message("	Essenzrune: |c66FF00 Deteri")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	--Jewelery Glyphs
	if((Enchanter.Essence.Dakeipa == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Kuoko == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Makderi == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Taderi == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Denima == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Haoko == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Kaderi == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Makderi == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Makkoma == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Meip == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Oru == true and Enchanter.Potency.haveSubtractive == true)
	or (Enchanter.Essence.Rakeipa == true and Enchanter.Potency.haveSubtractive == true)

	or (Enchanter.Essence.Taderi == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Okoma == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Makkoma == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Kaderi == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Denima == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Oru == true and Enchanter.Potency.haveAdditive == true)
	or (Enchanter.Essence.Makderi == true and Enchanter.Potency.haveAdditive == true)

	and (Enchanter.Aspect.hasAspect == true	)) then
		mw:add_message("")
		mw:add_message("|c00ff00".."--Verfügbare Schmuckglyphen--")
		mw:add_message("")
	end

	if(Enchanter.Essence.Dakeipa == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Frostresistenz")
		mw:add_message("	--Gewährt Frostresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Dakeipa")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Kuoko == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Giftresistenz")
		mw:add_message("	--Gewährt Giftresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Kuoko")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Makderi == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe des verringerten magischen Schadens")
		mw:add_message("	--Gewährt Magieresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Makderi")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Taderi == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe des verringerten physischen Schadens")
		mw:add_message("	--Gewährt Rüstung")
		mw:add_message("	Essenzrune: |c66FF00 Taderi")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Denima == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Fähigkeitenkostenminderung")
		mw:add_message("	--Verringert die Ausdauerkosten von Fähigkeiten")
		mw:add_message("	Essenzrune: |c66FF00 Denima")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end
	if (Enchanter.Essence.Haoko == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Seuchenresistenz")
		mw:add_message("	--Gewährt Seuchenresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Haoko")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Kaderi == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe des Abschirmens")
		mw:add_message("	--Verringert die Kosten von Schilschlägen und die Kosten beim Blocken")
		mw:add_message("	Essenzrune: |c66FF00 Kaderi")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Makderi == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe des verringerten magischen Schadens")
		mw:add_message("	--Gewährt Magieresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Makderi")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Makkoma == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Zauberkostenminderung")
		mw:add_message("	--Verringert die Magickakosten von Zaubern")
		mw:add_message("	Essenzrune: |c66FF00 Makkoma")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Meip == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Schockresistenz")
		mw:add_message("	--Gewährt Blitzresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Meip")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end
	if (Enchanter.Essence.Oru == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe des Tranktempos")
		mw:add_message("	--Tränke mit einer geringeren Stufe als der Gegenstand klingen 5 Sekunden schneller ab")
		mw:add_message("	Essenzrune: |c66FF00 Oru")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Rakeipa == true and Enchanter.Potency.haveSubtractive == true) then
		mw:add_message("|cffe500".."	Glyphe der Feuerresistenz")
		mw:add_message("	--Gewährt Flammenresistenz")
		mw:add_message("	Essenzrune: |c66FF00 Rakeipa")
		mw:add_message(ReduktivPotency[1])
		mw:add_message(ReduktivPotency[2])
		mw:add_message(ReduktivPotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Taderi == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des erhöhten physischen Schadens")
		mw:add_message("	--Gewährt Waffenschaden")
		mw:add_message("	Essenzrune: |c66FF00 Taderi")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Okoma == true and Enchanter.Potency.haveAdditive == true)  then
		mw:add_message("|cffe500".."	Glyphe der Lebensregeneration")
		mw:add_message("	--Gewährt Lebensregeneration")
		mw:add_message("	Essenzrune: |c66FF00 Okoma")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Makkoma == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Magickaregeneration")
		mw:add_message("	--Gewährt Magickaregeneration")
		mw:add_message("	Essenzrune: |c66FF00 Makkoma")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end
	if (Enchanter.Essence.Kaderi == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des Einschlags")
		mw:add_message("	--Erhöht den Schlagschaden bei Schildschlägen")
		mw:add_message("	Essenzrune: |c66FF00 Kaderi")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Denima == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Ausdauerregeneration")
		mw:add_message("	--Gewährt Ausdauerregeneration")
		mw:add_message("	Essenzrune: |c66FF00 Denima")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Oru == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe der Trankverbesserung")
		mw:add_message("	--Verstärkt die Wirkung von Tränken")
		mw:add_message("	Essenzrune: |c66FF00 Oru")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		mw:add_message("	_________________________________________________________")
	end

	if (Enchanter.Essence.Makderi == true and Enchanter.Potency.haveAdditive == true) then
		mw:add_message("|cffe500".."	Glyphe des erhöhten magischen Schadens")
		mw:add_message("	--Gewährt Zauberschaden")
		mw:add_message("	Essenzrune: |c66FF00 Makderi")
		mw:add_message(AdativePotency[1])
		mw:add_message(AdativePotency[2])
		mw:add_message(AdativePotency[3])
		mw:add_message(Aspect)
		-- mw:add_message("	_________________________________________________________")
	end

	end
end

EVENT_MANAGER:RegisterForEvent("Enchanter", EVENT_ADD_ON_LOADED, on_addon_load)
